const Alexa = require('ask-sdk-core');
const https = require('https');
const juegos = ['ordena las sílabas', 'cuenta las sílabas', 'las adivinanzas', 'la sílaba oculta', 'los antónimos', 'repite la palabra'];

const LaunchRequestHandler = {
    canHandle(handlerInput) {
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'LaunchRequest';
    },
    handle(handlerInput) {
        const speakOutput = 'Bienvenido a Habla Conmigo. ¿Es la primera vez que juegas?';

        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        sessionAttributes.juegoElegido = 'ninguno';
        
        sessionAttributes.idUsuario;
        sessionAttributes.nombreUsuario;
        sessionAttributes.edad;
        
        var APL_simple = require('./documents/APL_simple.json');
        
        if (
          Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
            'Alexa.Presentation.APL'
          ]
        ) {
          handlerInput.responseBuilder.addDirective({
            type: 'Alexa.Presentation.APL.RenderDocument',
            document: APL_simple,
            datasources: {
              myData: {
                title: '¿Es la primera vez que juegas?',
                body: 'Di sí o no',
              },
            },
          });
    }

        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
    }
};


const RegistroUsuarioIntentHandler = {
    canHandle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
        && sessionAttributes.juegoElegido === 'ninguno'
        && Alexa.getIntentName(handlerInput.requestEnvelope) === 'AMAZON.YesIntent';
        
    },
    handle(handlerInput) {
        
        const speakOutput = `¡Genial! Para empezar a jugar es necesario que me digas un número para identificarte,
                            tu nombre y tu edad`;
        
        var APL_simple = require('./documents/APL_simple.json');
        
        if (
          Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
            'Alexa.Presentation.APL'
          ]
        ) {
          handlerInput.responseBuilder.addDirective({
            type: 'Alexa.Presentation.APL.RenderDocument',
            document: APL_simple,
            datasources: {
              myData: {
                title: '¡Bienvenido!',
                body: 'Mi id es el número _ soy _ y tengo _ años',
              },
            },
          });
    }
        
        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
        
    }
};


const CrearUsuarioIntentHandler = {
  canHandle(handlerInput) {
    const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();

    return (
      Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest' &&
      sessionAttributes.juegoElegido === 'ninguno' &&
      Alexa.getIntentName(handlerInput.requestEnvelope) === 'RegistroUsuarioIntent'
    );
  },
  async handle(handlerInput) {
    var speakOutput;
    var title;
    var body;

    const { requestEnvelope } = handlerInput;
    const id = handlerInput.requestEnvelope.request.intent.slots.id.value;
    const nombreminusculas = handlerInput.requestEnvelope.request.intent.slots.nombre.value;
    const anios = handlerInput.requestEnvelope.request.intent.slots.edad.value;
    
    const nombre = nombreminusculas.charAt(0).toUpperCase() + nombreminusculas.slice(1);

    const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
    sessionAttributes.idUsuario = id;
    sessionAttributes.nombreUsuario = nombre;
    sessionAttributes.edad = anios;
    handlerInput.attributesManager.setSessionAttributes(sessionAttributes);

    const payload = {
      idSkill: 'c7800aee8f9287a60ffe835984a38431',
      idUsuario: sessionAttributes.idUsuario,
      nombreUsuario: sessionAttributes.nombreUsuario,
      edad: sessionAttributes.edad,
    };

    const options = {
      hostname: 'www.it.uniovi.es',
      port: 443,
      path: '/hosesbackend/skillTrastornosLectura.php',
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'Content-Length': Buffer.byteLength(JSON.stringify(payload)),
        'Authorization': 'Basic ' + Buffer.from('lfonteriz:aaa1674unTFG').toString('base64'),
      },
    };

    return new Promise((resolve, reject) => {
      const req = https.request(options, (res) => {
        res.setEncoding('utf8');
        let returnData = '';

        res.on('data', (chunk) => {
          returnData += chunk;
        });

        res.on('end', () => {
          if (res.statusCode === 201) {
              
            speakOutput = `Usuario ${sessionAttributes.nombreUsuario} creado con éxito. Repite tu id para empezar a jugar`;
            title = `Hola ${sessionAttributes.nombreUsuario}`;
            body = 'Registrado con éxito';
            
          } else if (res.statusCode === 400) {
              
            speakOutput = `Solicitud mal formulada`;
            title = 'Error 400';
            body = 'Solicitud mal formulada';
            
          } else if (res.statusCode === 406) {
              
            speakOutput = `Ya hay un usuario registrado con ese id`;
            title = 'Error 406';
            body = 'ID ya registrado';
            
          } else {
            reject(new Error(`Error ${res.statusCode}: Error inesperado`));
          }

          const responseBuilder = handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput);

          if (
            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)['Alexa.Presentation.APL']
          ) {
            const APL_simple = require('./documents/APL_simple.json');
            responseBuilder.addDirective({
              type: 'Alexa.Presentation.APL.RenderDocument',
              token: 'myAPLToken',
              document: APL_simple,
              datasources: {
                myData: {
                  title: title,
                  body: body,
                },
              },
            });
          }

          resolve(responseBuilder.getResponse());
        });

        res.on('error', (error) => {
          reject(error);
        });
      });

      req.write(JSON.stringify(payload));
      req.end();
    });
  },
};



const UsuarioRegistradoIntentHandler = {
    canHandle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
        && sessionAttributes.juegoElegido === 'ninguno'
        && Alexa.getIntentName(handlerInput.requestEnvelope) === 'AMAZON.NoIntent';
        
    },
    handle(handlerInput) {
        
        const speakOutput = '¡Genial! Dime tu id para que podamos jugar';
        
        var APL_simple = require('./documents/APL_simple.json');
        
        if (
          Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
            'Alexa.Presentation.APL'
          ]
        ) {

          handlerInput.responseBuilder.addDirective({
            type: 'Alexa.Presentation.APL.RenderDocument',
            document: APL_simple,
            datasources: {
              myData: {
                title: '¡Hola de nuevo!',
                body: 'Es el _',
                },
                },
            });
        }
        
        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
        
    }
};


const BienvenidaIntentHandler = {
  canHandle(handlerInput) {
    const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();

    return (
      Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest' &&
      sessionAttributes.juegoElegido === 'ninguno' &&
      Alexa.getIntentName(handlerInput.requestEnvelope) === 'IdUsuarioIntent'
    );
  },

  async handle(handlerInput) {
    let speakOutput;
    let title;
    let body;
    var APL_simple = require('./documents/APL_simple.json');

    const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
    sessionAttributes.nivelOrdenarSilabas = 'ninguno';
    sessionAttributes.nivelContarSilabas = 'ninguno';
    sessionAttributes.nivelAdivinanzas = 'ninguno';
    sessionAttributes.nivelAntonimos = 'ninguno';
    sessionAttributes.nivelRepetirPalabra = 'ninguno';

    const { requestEnvelope } = handlerInput;
    const id = handlerInput.requestEnvelope.request.intent.slots.idUsuario.value;
    sessionAttributes.idUsuario = id;

    const options = {
      hostname: 'www.it.uniovi.es',
      port: 443,
      path: `/hosesbackend/skillTrastornosLectura.php?idSkill=c7800aee8f9287a60ffe835984a38431&idUsuario=${id}`,
      method: 'GET',
      auth: 'lfonteriz:aaa1674unTFG',
      headers: {
        'Content-Type': 'application/json'
      }
    };

    await new Promise((resolve, reject) => {
      const req = https.request(options, res => {
        res.setEncoding('utf8');
        let responseData = '';

        res.on('data', chunk => {
          responseData += chunk;
        });

        res.on('end', () => {
            
            if (res.statusCode === 200) {
                
                // Parsea la respuesta JSON
                const usuarioTodo = JSON.parse(responseData);
                const usuario = usuarioTodo["0"];

                // Se encontró un usuario válido
                // Guardamos sus valores
                sessionAttributes.nombreUsuario = usuario.nombreUsuario;
                sessionAttributes.edad = usuario.edad;
                sessionAttributes.idUsuario = usuario.objid;
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);

                speakOutput = `¡Hola ${sessionAttributes.nombreUsuario}! Hay seis juegos disponibles. ¿A cuál te gustaría jugar?`;
                
                var APL_juegos = require('./documents/APL_juegos.json');

                if (Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)['Alexa.Presentation.APL']) {
                  handlerInput.responseBuilder.addDirective({
                    type: 'Alexa.Presentation.APL.RenderDocument',
                    document: APL_juegos,
                  });
                }
                
                
            } else if (res.statusCode === 404) {
                  
                speakOutput = `No se ha encontrado ningún usuario con ese ID`;
                title = 'Error 404';
                body = 'Ningún usuario registrado con ese ID';
                
                if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                      ]
                    ) {
                      // add a directive to render our simple template
                      handlerInput.responseBuilder.addDirective({
                        type: 'Alexa.Presentation.APL.RenderDocument',
                        document: APL_simple,
                        datasources: {
                          myData: {
                            title: title,
                            body: body,
                          },
                        },
                      });
                }  


            } else if (res.statusCode === 400) {
              
                speakOutput = `Solicitud mal formulada`;
                
                if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                      ]
                    ) {
                      // add a directive to render our simple template
                      handlerInput.responseBuilder.addDirective({
                        type: 'Alexa.Presentation.APL.RenderDocument',
                        document: APL_simple,
                        datasources: {
                          myData: {
                            title: 'Error 400',
                            body: 'Solicitud mal formulada',
                          },
                        },
                      });
                } 
                
            } else {
                // No se encontró un usuario válido
                speakOutput = 'No se ha encontrado un usuario con ese ID.';
                
                if (
                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                    'Alexa.Presentation.APL'
                  ]
                ) {
                  // add a directive to render our simple template
                  handlerInput.responseBuilder.addDirective({
                    type: 'Alexa.Presentation.APL.RenderDocument',
                    document: APL_simple,
                    datasources: {
                      myData: {
                        title: 'Error',
                        body: 'No se ha encontrado el usuario',
                      },
                    },
                  });
            }  
                        
                  }

          resolve();
        });
      });

      req.on('error', error => {
        speakOutput = 'Lo siento, no puedo obtener los detalles del usuario en este momento.';
        
        if (
          Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
            'Alexa.Presentation.APL'
          ]
        ) {
          // add a directive to render our simple template
          handlerInput.responseBuilder.addDirective({
            type: 'Alexa.Presentation.APL.RenderDocument',
            document: APL_simple,
            datasources: {
              myData: {
                title: 'Error',
                body: 'No se pueden obtener los datos',
              },
            },
          });
        }  

        reject();
      });

      req.end();
    });


    return handlerInput.responseBuilder
      .speak(speakOutput)
      .reprompt(speakOutput)
      .getResponse();

  }
};


const SeleccionarJuegoIntentHandler = {
    
    canHandle(handlerInput) {

        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'SeleccionarJuegoIntent';
    },
    
    handle(handlerInput) {
        
        const juego = (handlerInput.requestEnvelope.request.intent.slots.juegoElegido.value).toLowerCase();
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        sessionAttributes.juegoElegido = juego;
        //handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
        
        var speakOutput = '';
        var title = '';
        var subtitle = '';
        
        if (sessionAttributes.juegoElegido === juegos[0]){
            
            speakOutput = `Has elegido jugar a ordena las sílabas. Este juego tiene cuatro niveles disponibles.
                ¿A cuál de ellos te gustaría jugar?`;
            
            title = 'Elige un nivel';
            subtitle = 'Nivel 1, 2, 3 o 4';
            
        } else if (sessionAttributes.juegoElegido === juegos[1]){
            
            speakOutput = `Has elegido jugar a cuenta las sílabas. Este juego tiene dos niveles disponibles.
                ¿A cuál de ellos te gustaría jugar?`;
            
            title = 'Elige un nivel';
            subtitle = 'Nivel 1 o 2';
            
        } else if (sessionAttributes.juegoElegido === juegos[2]){
            
            speakOutput = `Has elegido jugar a las adivinanzas. Este juego tiene tres niveles disponibles.
                ¿A cuál de ellos te gustaría jugar?`;
            
            title = 'Elige un nivel';
            subtitle = 'Nivel 1, 2 o 3';
            
        } else if (sessionAttributes.juegoElegido === juegos[3]){
            
            speakOutput = `Este juego solo tiene un nivel disponible. Elígelo para empezar a jugar`;
            
            title = 'Elige un nivel';
            subtitle = 'Nivel 1';
            
        } else if (sessionAttributes.juegoElegido === juegos[4]){
            
            speakOutput = `Has elegido jugar a los antónimos. Este juego tiene dos niveles disponibles.
                ¿A cuál de ellos te gustaría jugar?`;
            
            title = 'Elige un nivel';
            subtitle = 'Nivel 1 o 2';
            
        } else if (sessionAttributes.juegoElegido === juegos[5]){
            
            speakOutput = `Has elegido jugar a repite la palabra. Puedes jugar con 4 letras distintas.
                Elige el nivel que corresponde con la letra que quieras`;
            
            title = 'Elige un nivel';
            subtitle = 'Nivel 1 (letra L), 2 (letra R), 3 (letra S) o 4 (letra D)';
            
        } else{
            
            speakOutput = 'Elige un juego disponible';
            
            title = 'Elige un juego disponible';
            
        }
        
        var APL_simple = require('./documents/APL_simple.json');
        
        if (
          Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
            'Alexa.Presentation.APL'
          ]
        ) {
          // add a directive to render our simple template
          handlerInput.responseBuilder.addDirective({
            type: 'Alexa.Presentation.APL.RenderDocument',
            document: APL_simple,
            datasources: {
              myData: {
                title: title,
                body: subtitle,
              },
            },
          });
    }  

        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
    }
};


const OrdenarSilabasHandler = {
    canHandle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && sessionAttributes.juegoElegido === juegos[0]
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'SeleccionarNivelIntent'
    },
    
    async handle(handlerInput) {
        const nivel = handlerInput.requestEnvelope.request.intent.slots.numNivel.value;
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        sessionAttributes.nivelOrdenarSilabas = nivel;
        handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
        
        var speakOutput = '';
        var title = '';
        var subtitle = '';
        var body = '';
        var inicio;
        var APL_pistatexto = require('./documents/APL_pistatexto.json');
        var APL_simple = require('./documents/APL_simple.json');
        
        const options = {
          hostname: 'www.it.uniovi.es',
          port: 443,
          path: `/hosesbackend/skillTrastornosLectura.php?idSkill=c7800aee8f9287a60ffe835984a38431&idActividad=1&nivelActividad=${sessionAttributes.nivelOrdenarSilabas}`,
          method: 'GET',
          auth: 'lfonteriz:aaa1674unTFG',
          headers: {
            'Content-Type': 'application/json'
          }
        };
    
        await new Promise((resolve, reject) => {
          const req = https.request(options, res => {
            res.setEncoding('utf8');
            let responseData = '';
    
            res.on('data', chunk => {
              responseData += chunk;
            });
    
            res.on('end', () => {
                
                if (res.statusCode === 200) {
                    
                    const juegosTodo = JSON.parse(responseData);
              
                    const getRandomOrdenar = function(pastPalabras = []) {
                      const filtrado = Object.values(juegosTodo).filter(p => !pastPalabras.find(pp => pp.objid === p.objid));
                      
                      return filtrado.length > 0
                        ? filtrado[Math.floor(Math.random() * filtrado.length)]
                        : {"objid": 0, "palabra": null, "solucion": null};
                    };
                    
                    if (juegosTodo){
                        
                        if (sessionAttributes.nivelOrdenarSilabas === '1'){
            
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelUnoOrdenar') &&
                                sessionAttributes.current_wordNivelUnoOrdenar !== null
                            ) {
                                speakOutput = `¿Cuál es la palabra oculta en ${sessionAttributes.current_wordNivelUnoOrdenar.palabra}?`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_pistatexto,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelUnoOrdenar.palabra}`,
                                        subtitle: `Pista: ${sessionAttributes.current_wordNivelUnoOrdenar.pistaPalabra}`,
                                        body: 'Es _',
                                      },
                                    },
                                  });
                                
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelUnoOrdenar'))
                                sessionAttributes.past_wordsNivelUnoOrdenar = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelUnoOrdenar = getRandomOrdenar(sessionAttributes.past_wordsNivelUnoOrdenar);
                            const pistaUnoOrdenar = palabraNivelUnoOrdenar.pistaPalabra;
                            title = palabraNivelUnoOrdenar.palabra;
                            subtitle = `Pista: ${pistaUnoOrdenar}`;
                            body = 'Es _';
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelUnoOrdenar.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: 'Te has pasado el juego. Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelUnoOrdenar = palabraNivelUnoOrdenar;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `¿Qué palabra se esconde en ${palabraNivelUnoOrdenar.palabra}?`;
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_pistatexto,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        subtitle: subtitle,
                                        body: body,
                                      },
                                    },
                                  });
                                
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } else if (sessionAttributes.nivelOrdenarSilabas === '2'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelDosOrdenar') &&
                                sessionAttributes.current_wordNivelDosOrdenar !== null
                            ) {
                                speakOutput = `¿Cuál es la palabra oculta en ${sessionAttributes.current_wordNivelDosOrdenar.palabra}?`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelDosOrdenar.palabra}`,
                                        body: 'Es _',
                                      },
                                    },
                                  });
                                
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelDosOrdenar'))
                                sessionAttributes.past_wordsNivelDosOrdenar = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelDosOrdenar = getRandomOrdenar(sessionAttributes.past_wordsNivelDosOrdenar);
                            title = palabraNivelDosOrdenar.palabra;
                            body = 'Es _';
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelDosOrdenar.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: 'Te has pasado el juego. Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelDosOrdenar = palabraNivelDosOrdenar;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `¿Qué palabra se esconde en ${palabraNivelDosOrdenar.palabra}?`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        body: body,
                                      },
                                    },
                                  });
    
                                
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } else if (sessionAttributes.nivelOrdenarSilabas === '3'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelTresOrdenar') &&
                                sessionAttributes.current_wordNivelTresOrdenar !== null
                            ) {
                                speakOutput = `¿Cuál es la palabra oculta en ${sessionAttributes.current_wordNivelTresOrdenar.palabra}?`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_pistatexto,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelTresOrdenar.palabra}`,
                                        subtitle: `Pista: ${sessionAttributes.current_wordNivelTresOrdenar.pistaPalabra}`,
                                        body: 'Es _',
                                      },
                                    },
                                  });
                                
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelTresOrdenar'))
                                sessionAttributes.past_wordsNivelTresOrdenar = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelTresOrdenar = getRandomOrdenar(sessionAttributes.past_wordsNivelTresOrdenar);
                            const pistaTresOrdenar = palabraNivelTresOrdenar.pistaPalabra;
                            title = palabraNivelTresOrdenar.palabra;
                            subtitle = `Pista: ${pistaTresOrdenar}`;
                            body = `Es _`;
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelTresOrdenar.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: 'Te has pasado el juego. Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelTresOrdenar = palabraNivelTresOrdenar;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `¿Qué palabra se esconde en ${palabraNivelTresOrdenar.palabra}?`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_pistatexto,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        subtitle: subtitle,
                                        body: body,
                                      },
                                    },
                                  });
                                
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } else if (sessionAttributes.nivelOrdenarSilabas === '4'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelCuatroOrdenar') &&
                                sessionAttributes.current_wordNivelCuatroOrdenar !== null
                            ) {
                                speakOutput = `¿Cuál es la palabra oculta en ${sessionAttributes.current_wordNivelCuatroOrdenar.palabra}?`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelCuatroOrdenar.palabra}`,
                                        body: 'Es _',
                                      },
                                    },
                                  });
                                
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelCuatroOrdenar'))
                                sessionAttributes.past_wordsNivelCuatroOrdenar = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelCuatroOrdenar = getRandomOrdenar(sessionAttributes.past_wordsNivelCuatroOrdenar);
                            title = palabraNivelCuatroOrdenar.palabra;
                            body = 'Es _';
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelCuatroOrdenar.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
    
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: 'Te has pasado el juego. Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelCuatroOrdenar = palabraNivelCuatroOrdenar;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `¿Qué palabra se esconde en ${palabraNivelCuatroOrdenar.palabra}?`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        body: body,
                                      },
                                    },
                                  });
                                
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } else {
                            
                            speakOutput = 'Error en el nivel'
                            if (
                                Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                ]
                                ) {
                                    handlerInput.responseBuilder.addDirective({
                                        type: 'Alexa.Presentation.APL.RenderDocument',
                                        document: APL_simple,
                                            datasources: {
                                                myData: {
                                                    title: 'Error',
                                                    body: 'Nivel incorrecto',
                                                },
                                            },
                                        });
                                    }
                            
                        }
                        
                    }
                      
                    
                } else if (res.statusCode === 404) {
                  
                speakOutput = `Elige un nivel disponible para Ordena las Sílabas`;
                title = 'Elige un nivel disponible';
                body = 'Nivel 1, 2, 3 o 4';
                
                if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                      ]
                    ) {
                      // add a directive to render our simple template
                      handlerInput.responseBuilder.addDirective({
                        type: 'Alexa.Presentation.APL.RenderDocument',
                        document: APL_simple,
                        datasources: {
                          myData: {
                            title: title,
                            body: body,
                          },
                        },
                      });
                }  


            } else if (res.statusCode === 400) {
              
                speakOutput = `Solicitud mal formulada`;
                
                if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                      ]
                    ) {
                      // add a directive to render our simple template
                      handlerInput.responseBuilder.addDirective({
                        type: 'Alexa.Presentation.APL.RenderDocument',
                        document: APL_simple,
                        datasources: {
                          myData: {
                            title: 'Error 400',
                            body: 'Solicitud mal formulada',
                          },
                        },
                      });
                } 
                
            } else {
                          
                        // No se encontró un juego válido
                        speakOutput = 'No se ha podido obtener un juego';
                        
                        if (
                              Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                              ]
                            ) {
                              handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                  myData: {
                                    title: 'Error',
                                    body: 'No se han encontrado datos de juego',
                                  },
                                },
                              });
                            
                            }
                        
                        
                      }
        
                  resolve();
                });
                
              });
    
          req.on('error', error => {
            speakOutput = 'Lo siento, no puedo obtener los detalles de un juego en este momento.';
            if (
                Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                    'Alexa.Presentation.APL'
                ]
                ) {
                    handlerInput.responseBuilder.addDirective({
                        type: 'Alexa.Presentation.APL.RenderDocument',
                        document: APL_simple,
                            datasources: {
                                myData: {
                                    title: 'Error',
                                    body: 'No se pueden obtener los datos',
                                },
                            },
                        });
                    }
    
            reject();
          });
    
          req.end();
        });

        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
    }
};


const OrdenarSilabasIntentHandler = {
    
    canHandle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && sessionAttributes.juegoElegido === juegos[0]
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'ContestarPalabraIntent';
            
    },
    
    handle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        const nivelOrdenarComparar = sessionAttributes.nivelOrdenarSilabas;
        
        var speakOutput = '';
        var title = '';
        var subtitle = '';
        var body = '';
        var APL_simple = require('./documents/APL_simple.json');
        var acierto;
        var error;
        var final;
        var duracion;
        var duracionMili;
        
        if (nivelOrdenarComparar === '1') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelUnoOrdenar') &&
                    sessionAttributes.current_wordNivelUnoOrdenar === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelUnoOrdenar')
                ) {
                    speakOutput =
                        "Lo siento, no hay una palabra para ordenar ahora mismo. ¿Quieres una palabra para ordenar?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una palabra para odenar',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelUnoOrdenar = handlerInput.requestEnvelope.request.intent.slots.respuestaPalabra.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                
                // Comprobamos la respuesta
                const comprobarNivelUnoOrdenar = require('./functions/comprobar.js');

                const aciertoNivelUnoOrdenar = comprobarNivelUnoOrdenar.checkAnswer(
                    sessionAttributes.current_wordNivelUnoOrdenar,
                    respuesta_usuarioNivelUnoOrdenar
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelUnoOrdenar.push(sessionAttributes.current_wordNivelUnoOrdenar);
                const palabra_mostrarNivelUnoOrdenar = sessionAttributes.current_wordNivelUnoOrdenar.palabra;
                const palabra_solucionNivelUnoOrdenar = sessionAttributes.current_wordNivelUnoOrdenar.solucion;
                sessionAttributes.current_wordNivelUnoOrdenar = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelUnoOrdenar'))
                  sessionAttributes.puntuacionNivelUnoOrdenar = 0;
                  

                
                // Comprobación respuesta
                if (aciertoNivelUnoOrdenar) {
                    sessionAttributes.puntuacionNivelUnoOrdenar += 1;
                    
                    acierto = 1;
                    error = 0;
                    
                    speakOutput = `¡Wow! ¡Adivinaste que ${palabra_solucionNivelUnoOrdenar} se escondía en ${palabra_mostrarNivelUnoOrdenar}. 
                    Ahora tu puntuación del nivel 1 es ${sessionAttributes.puntuacionNivelUnoOrdenar}. Elige un nivel u otro juego para seguir jugando`;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Enhorabuena!',
                                        body: 'Elige un nivel u otro juego',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... No has encontrado la palabra escondida en ${palabra_mostrarNivelUnoOrdenar}. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(1, sessionAttributes.idUsuario, duracion, acierto, error, 1)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
                
            
        } else if (nivelOrdenarComparar === '2') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelDosOrdenar') &&
                    sessionAttributes.current_wordNivelDosOrdenar === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelDosOrdenar')
                ) {
                    speakOutput =
                        "Lo siento, no hay una palabra para ordenar ahora mismo. ¿Quieres una palabra para ordenar?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una palabra para odenar',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelDosOrdenar = handlerInput.requestEnvelope.request.intent.slots.respuestaPalabra.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelDosOrdenar = require('./functions/comprobar.js');

                const aciertoNivelDosOrdenar = comprobarNivelDosOrdenar.checkAnswer(
                    sessionAttributes.current_wordNivelDosOrdenar,
                    respuesta_usuarioNivelDosOrdenar
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelDosOrdenar.push(sessionAttributes.current_wordNivelDosOrdenar);
                const palabra_mostrarNivelDosOrdenar = sessionAttributes.current_wordNivelDosOrdenar.palabra;
                const palabra_solucionNivelDosOrdenar = sessionAttributes.current_wordNivelDosOrdenar.solucion;
                sessionAttributes.current_wordNivelDosOrdenar = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelDosOrdenar'))
                  sessionAttributes.puntuacionNivelDosOrdenar = 0;

                
                // Comprobación respuesta
                if (aciertoNivelDosOrdenar) {
                    sessionAttributes.puntuacionNivelDosOrdenar += 1;
                    
                    speakOutput = `¡Wow! ¡Adivinaste que ${palabra_solucionNivelDosOrdenar} se escondía en ${palabra_mostrarNivelDosOrdenar}. 
                    Ahora tu puntuación del nivel 2 es ${sessionAttributes.puntuacionNivelDosOrdenar}. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 1;
                    error = 0;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Enhorabuena!',
                                        body: 'Elige un nivel u otro juego',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... No has encontrado la palabra escondida en ${palabra_mostrarNivelDosOrdenar}. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(1, sessionAttributes.idUsuario, duracion, acierto, error, 2)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else if (nivelOrdenarComparar === '3') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelTresOrdenar') &&
                    sessionAttributes.current_wordNivelTresOrdenar === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelTresOrdenar')
                ) {
                    speakOutput =
                        "Lo siento, no hay una palabra para ordenar ahora mismo. ¿Quieres una palabra para ordenar?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una palabra para odenar',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelTresOrdenar = handlerInput.requestEnvelope.request.intent.slots.respuestaPalabra.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelTresOrdenar = require('./functions/comprobar.js');

                const aciertoNivelTresOrdenar = comprobarNivelTresOrdenar.checkAnswer(
                    sessionAttributes.current_wordNivelTresOrdenar,
                    respuesta_usuarioNivelTresOrdenar
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelTresOrdenar.push(sessionAttributes.current_wordNivelTresOrdenar);
                const palabra_mostrarNivelTresOrdenar = sessionAttributes.current_wordNivelTresOrdenar.palabra;
                const palabra_solucionNivelTresOrdenar = sessionAttributes.current_wordNivelTresOrdenar.solucion;
                sessionAttributes.current_wordNivelTresOrdenar = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelTresOrdenar'))
                  sessionAttributes.puntuacionNivelTresOrdenar = 0;

                
                // Comprobación respuesta
                if (aciertoNivelTresOrdenar) {
                    sessionAttributes.puntuacionNivelTresOrdenar += 1;
                    
                    speakOutput = `¡Wow! ¡Adivinaste que ${palabra_solucionNivelTresOrdenar} se escondía en ${palabra_mostrarNivelTresOrdenar}. 
                    Ahora tu puntuación del nivel 3 es ${sessionAttributes.puntuacionNivelTresOrdenar}. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 1;
                    error = 0;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Enhorabuena!',
                                        body: 'Elige un nivel u otro juego',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... No has encontrado la palabra escondida en ${palabra_mostrarNivelTresOrdenar}. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(1, sessionAttributes.idUsuario, duracion, acierto, error, 3)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else if (nivelOrdenarComparar === '4') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelCuatroOrdenar') &&
                    sessionAttributes.current_wordNivelCuatroOrdenar === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelCuatroOrdenar')
                ) {
                    speakOutput =
                        "Lo siento, no hay una palabra para ordenar ahora mismo. ¿Quieres una palabra para ordenar?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una palabra para odenar',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelCuatroOrdenar = handlerInput.requestEnvelope.request.intent.slots.respuestaPalabra.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelCuatroOrdenar = require('./functions/comprobar.js');

                const aciertoNivelCuatroOrdenar = comprobarNivelCuatroOrdenar.checkAnswer(
                    sessionAttributes.current_wordNivelCuatroOrdenar,
                    respuesta_usuarioNivelCuatroOrdenar
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelCuatroOrdenar.push(sessionAttributes.current_wordNivelCuatroOrdenar);
                const palabra_mostrarNivelCuatroOrdenar = sessionAttributes.current_wordNivelCuatroOrdenar.palabra;
                const palabra_solucionNivelCuatroOrdenar = sessionAttributes.current_wordNivelCuatroOrdenar.solucion;
                sessionAttributes.current_wordNivelCuatroOrdenar = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelCuatroOrdenar'))
                  sessionAttributes.puntuacionNivelCuatroOrdenar = 0;

                
                // Comprobación respuesta
                if (aciertoNivelCuatroOrdenar) {
                    sessionAttributes.puntuacionNivelCuatroOrdenar += 1;
                    
                    speakOutput = `¡Wow! ¡Adivinaste que ${palabra_solucionNivelCuatroOrdenar} se escondía en ${palabra_mostrarNivelCuatroOrdenar}. 
                    Ahora tu puntuación del nivel 4 es ${sessionAttributes.puntuacionNivelCuatroOrdenar}. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 1;
                    error = 0;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Enhorabuena!',
                                        body: 'Elige un nivel u otro juego',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... No has encontrado la palabra escondida en ${palabra_mostrarNivelCuatroOrdenar}. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(1, sessionAttributes.idUsuario, duracion, acierto, error, 4)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else {
            
            speakOutput = 'Error de nivel';
            if (
                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                    'Alexa.Presentation.APL'
                    ]
                    ) {
                        handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                            datasources: {
                                  myData: {
                                    title: 'Error',
                                    body: 'No se han encontrado datos de juego',
                                  },
                                },
                              });
                            
                            }
            
        }
        
        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
        
    }
    
};



const ContarSilabasHandler = {
    canHandle(handlerInput) {

        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && sessionAttributes.juegoElegido === juegos[1]
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'SeleccionarNivelIntent'
    },
    
    async handle(handlerInput) {
        const nivel = handlerInput.requestEnvelope.request.intent.slots.numNivel.value;
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        sessionAttributes.nivelContarSilabas = nivel;
        
        var speakOutput = '';
        var title = '';
        var subtitle = '';
        var body = '';
        var inicio;
        var APL_simple = require('./documents/APL_simple.json');
        
        const options = {
          hostname: 'www.it.uniovi.es',
          port: 443,
          path: `/hosesbackend/skillTrastornosLectura.php?idSkill=c7800aee8f9287a60ffe835984a38431&idActividad=2&nivelActividad=${sessionAttributes.nivelContarSilabas}`,
          method: 'GET',
          auth: 'lfonteriz:aaa1674unTFG',
          headers: {
            'Content-Type': 'application/json'
          }
        };
    
        await new Promise((resolve, reject) => {
          const req = https.request(options, res => {
            res.setEncoding('utf8');
            let responseData = '';
    
            res.on('data', chunk => {
              responseData += chunk;
            });
    
            res.on('end', () => {
                
                if (res.statusCode === 200) {
                    
                    const juegosTodo = JSON.parse(responseData);
              
                    const getRandomContar = function(pastPalabras = []) {
                      const filtrado = Object.values(juegosTodo).filter(p => !pastPalabras.find(pp => pp.objid === p.objid));
                      
                      return filtrado.length > 0
                        ? filtrado[Math.floor(Math.random() * filtrado.length)]
                        : {"objid": 0, "palabra": null, "solucion": null};
                    };
                    
                    if (juegosTodo) {
                          
                        if (sessionAttributes.nivelContarSilabas === '1'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelUnoContar') &&
                                sessionAttributes.current_wordNivelUnoContar !== null
                            ) {
                                speakOutput = `¿Cuántas sílabas tiene ${sessionAttributes.current_wordNivelUnoContar.palabra}?`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelUnoContar.palabra}`,
                                        body: 'Tiene _ sílabas',
                                      },
                                    },
                                  });
                                
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelUnoContar'))
                                sessionAttributes.past_wordsNivelUnoContar = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelUnoContar = getRandomContar(sessionAttributes.past_wordsNivelUnoContar);
                            title = palabraNivelUnoContar.palabra;
                            body = 'Tiene _ sílabas';
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelUnoContar.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`,
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelUnoContar = palabraNivelUnoContar;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `¿Cuántas sílabas tiene ${palabraNivelUnoContar.palabra}?`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        body: body,
                                      },
                                    },
                                  });
                                
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } else if (sessionAttributes.nivelContarSilabas === '2'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelDosContar') &&
                                sessionAttributes.current_wordNivelDosContar !== null
                            ) {
                                speakOutput = `¿Cuántas sílabas tiene ${sessionAttributes.current_wordNivelDosContar.palabra}?`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelDosContar.palabra}`,
                                        body: 'Tiene _ sílabas',
                                      },
                                    },
                                  });
                                
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelDosContar'))
                                sessionAttributes.past_wordsNivelDosContar = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelDosContar = getRandomContar(sessionAttributes.past_wordsNivelDosContar);
                            title = palabraNivelDosContar.palabra;
                            body = 'Tiene _ sílabas';
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelDosContar.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`,
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelDosContar = palabraNivelDosContar;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `¿Cuántas sílabas tiene ${palabraNivelDosContar.palabra}?`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        body: body,
                                      },
                                    },
                                  });
                                
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } else {
                            
                            speakOutput = 'Error en el nivel'
                        }
                    } 
                    
                } else if (res.statusCode === 404) {
                  
                    speakOutput = `Elige un nivel disponible para Cuenta las Sílabas`;
                    title = 'Elige un nivel disponible';
                    body = 'Nivel 1 o 2';
                    
                    if (
                          Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                            'Alexa.Presentation.APL'
                          ]
                        ) {
                          // add a directive to render our simple template
                          handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                            datasources: {
                              myData: {
                                title: title,
                                body: body,
                              },
                            },
                          });
                    }  
    
    
                } else if (res.statusCode === 400) {
                  
                    speakOutput = `Solicitud mal formulada`;
                    
                    if (
                          Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                            'Alexa.Presentation.APL'
                          ]
                        ) {
                          // add a directive to render our simple template
                          handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                            datasources: {
                              myData: {
                                title: 'Error 400',
                                body: 'Solicitud mal formulada',
                              },
                            },
                          });
                    } 
                    
                } else {
                          
                        // No se encontró un juego válido
                        speakOutput = 'No se ha podido obtener un juego';
                        
                        if (
                              Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                              ]
                            ) {
                              handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                  myData: {
                                    title: 'Error',
                                    body: 'No se han encontrado datos de juego',
                                  },
                                },
                              });
                            
                            }
                        
                        
                      }
        
                  resolve();
                });
                
              });
    
          req.on('error', error => {
            speakOutput = 'Lo siento, no puedo obtener los detalles de un juego en este momento.';
            if (
                Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                    'Alexa.Presentation.APL'
                ]
                ) {
                    handlerInput.responseBuilder.addDirective({
                        type: 'Alexa.Presentation.APL.RenderDocument',
                        document: APL_simple,
                            datasources: {
                                myData: {
                                    title: 'Error',
                                    body: 'No se pueden obtener los datos',
                                },
                            },
                        });
                    }
    
            reject();
          });
    
          req.end();
        });
        
        

        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
    }
};


const ContarSilabasIntentHandler = {
    
    canHandle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && sessionAttributes.juegoElegido === juegos[1]
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'ContestarContarSilabasIntent';
            
    },
    
    handle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        const nivelContarComparar = sessionAttributes.nivelContarSilabas;
        
        var speakOutput = '';
        var title = '';
        var subtitle = '';
        var body = '';
        var APL_simple = require('./documents/APL_simple.json');
        var acierto;
        var error;
        var final;
        var duracionMili;
        var duracion;
        
        if (nivelContarComparar === '1') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelUnoContar') &&
                    sessionAttributes.current_wordNivelUnoContar === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelUnoContar')
                ) {
                    speakOutput =
                        "Lo siento, no hay una palabra para contar sus sílabas ahora mismo. ¿Quieres una palabra para contar sus sílabas?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una palabra para contar sus sílabas',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelUnoContar = handlerInput.requestEnvelope.request.intent.slots.numSilabas.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelUnoContar = require('./functions/comprobar.js');

                const aciertoNivelUnoContar = comprobarNivelUnoContar.checkAnswer(
                    sessionAttributes.current_wordNivelUnoContar,
                    respuesta_usuarioNivelUnoContar
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelUnoContar.push(sessionAttributes.current_wordNivelUnoContar);
                const palabra_mostrarNivelUnoContar = sessionAttributes.current_wordNivelUnoContar.palabra;
                const palabra_solucionNivelUnoContar = sessionAttributes.current_wordNivelUnoContar.solucion;
                sessionAttributes.current_wordNivelUnoContar = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelUnoContar'))
                  sessionAttributes.puntuacionNivelUnoContar = 0;

                
                // Comprobación respuesta
                if (aciertoNivelUnoContar) {
                    sessionAttributes.puntuacionNivelUnoContar += 1;
                    
                    acierto = 1;
                    error = 0;
                    
                    speakOutput = `¡Wow! ¡Adivinaste que ${palabra_mostrarNivelUnoContar} tenía ${palabra_solucionNivelUnoContar} sílabas. 
                    Ahora tu puntuación del nivel 1 es ${sessionAttributes.puntuacionNivelUnoContar}. Elige un nivel u otro juego para seguir jugando`;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Enhorabuena!',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... No has adivinado el número de sílabas de ${palabra_mostrarNivelUnoContar}. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(2, sessionAttributes.idUsuario, duracion, acierto, error, 1)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else if (nivelContarComparar === '2') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelDosContar') &&
                    sessionAttributes.current_wordNivelDosContar === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelDosContar')
                ) {
                    speakOutput =
                        "Lo siento, no hay una palabra para contar sus sílabas ahora mismo. ¿Quieres una palabra para contar sus sílabas?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una palabra para contar sus sílabas',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelDosContar = handlerInput.requestEnvelope.request.intent.slots.numSilabas.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelDosContar = require('./functions/comprobar.js');

                const aciertoNivelDosContar = comprobarNivelDosContar.checkAnswer(
                    sessionAttributes.current_wordNivelDosContar,
                    respuesta_usuarioNivelDosContar
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelDosContar.push(sessionAttributes.current_wordNivelDosContar);
                const palabra_mostrarNivelDosContar = sessionAttributes.current_wordNivelDosContar.palabra;
                const palabra_solucionNivelDosContar = sessionAttributes.current_wordNivelDosContar.solucion;
                sessionAttributes.current_wordNivelDosContar = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelDosContar'))
                  sessionAttributes.puntuacionNivelDosContar = 0;

                
                // Comprobación respuesta
                if (aciertoNivelDosContar) {
                    sessionAttributes.puntuacionNivelDosContar += 1;
                    
                    acierto = 1;
                    error = 0;
                    
                    speakOutput = `¡Wow! ¡Adivinaste que ${palabra_mostrarNivelDosContar} tenía ${palabra_solucionNivelDosContar} sílabas. 
                    Ahora tu puntuación del nivel 2 es ${sessionAttributes.puntuacionNivelDosContar}. Elige un nivel u otro juego para seguir jugando`;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Enhorabuena!',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... No has adivinado el número de sílabas de ${palabra_mostrarNivelDosContar}. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(2, sessionAttributes.idUsuario, duracion, acierto, error, 2)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else {
            
            speakOutput = 'Error de nivel';
            if (
                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                    'Alexa.Presentation.APL'
                    ]
                    ) {
                        handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                            datasources: {
                                  myData: {
                                    title: 'Error',
                                    body: 'No se han encontrado datos de juego',
                                  },
                                },
                              });
                            
                            }
            
        }
        
        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
        
    }
    
};


const AdivinanzasHandler = {
    canHandle(handlerInput) {

        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && sessionAttributes.juegoElegido === juegos[2]
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'SeleccionarNivelIntent'
    },
    
    async handle(handlerInput) {
        const nivel = handlerInput.requestEnvelope.request.intent.slots.numNivel.value;
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        sessionAttributes.nivelAdivinanzas = nivel;
        
        var speakOutput = '';
        var title = '';
        var subtitle = '';
        var body = '';
        var foto = '';
        var inicio;
        var APL_pistatexto = require('./documents/APL_pistatexto.json');
        var APL_simple = require('./documents/APL_simple.json');
        var APL_pistafototexto = require('./documents/APL_pistafototexto.json');
        
        const options = {
          hostname: 'www.it.uniovi.es',
          port: 443,
          path: `/hosesbackend/skillTrastornosLectura.php?idSkill=c7800aee8f9287a60ffe835984a38431&idActividad=3&nivelActividad=${sessionAttributes.nivelAdivinanzas}`,
          method: 'GET',
          auth: 'lfonteriz:aaa1674unTFG',
          headers: {
            'Content-Type': 'application/json'
          }
        };
    
        await new Promise((resolve, reject) => {
          const req = https.request(options, res => {
            res.setEncoding('utf8');
            let responseData = '';
    
            res.on('data', chunk => {
              responseData += chunk;
            });
    
            res.on('end', () => {
                
                if (res.statusCode === 200) {
                    
                    const juegosTodo = JSON.parse(responseData);
              
                    const getRandomAdivinanza = function(pastPalabras = []) {
                      const filtrado = Object.values(juegosTodo).filter(p => !pastPalabras.find(pp => pp.objid === p.objid));
                      
                      return filtrado.length > 0
                        ? filtrado[Math.floor(Math.random() * filtrado.length)]
                        : {"objid": 0, "palabra": null, "solucion": null};
                    };
                    
                    if (juegosTodo) {
                          
                        if (sessionAttributes.nivelAdivinanzas === '1'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelUnoAdivinanzas') &&
                                sessionAttributes.current_wordNivelUnoAdivinanzas !== null
                            ) {
                                speakOutput = `${sessionAttributes.current_wordNivelUnoAdivinanzas.palabra}`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_pistafototexto,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelUnoAdivinanzas.palabra}`,
                                        subtitle: 'Es _',
                                        foto: `${sessionAttributes.current_wordNivelUnoAdivinanzas.pistaFoto}`,
                                      },
                                    },
                                  });
                                
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelUnoAdivinanzas'))
                                sessionAttributes.past_wordsNivelUnoAdivinanzas = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelUnoAdivinanzas = getRandomAdivinanza(sessionAttributes.past_wordsNivelUnoAdivinanzas);
                            const pistaUnoFotoAdivinanzas = palabraNivelUnoAdivinanzas.pistaFoto;
                            title = palabraNivelUnoAdivinanzas.palabra;
                            subtitle = 'Es _';
                            foto = pistaUnoFotoAdivinanzas;
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelUnoAdivinanzas.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`,
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelUnoAdivinanzas = palabraNivelUnoAdivinanzas;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `${palabraNivelUnoAdivinanzas.palabra}`;
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_pistafototexto,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        subtitle: subtitle,
                                        foto: foto,
                                      },
                                    },
                                  });
                                
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } else if (sessionAttributes.nivelAdivinanzas === '2'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelDosAdivinanzas') &&
                                sessionAttributes.current_wordNivelDosAdivinanzas !== null
                            ) {
                                speakOutput = `${sessionAttributes.current_wordNivelDosAdivinanzas.palabra}`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_pistatexto,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelDosAdivinanzas.palabra}`,
                                        subtitle: `${sessionAttributes.current_wordNivelDosAdivinanzas.pistaPalabra}`,
                                        body: 'Es _',
                                      },
                                    },
                                  });
                               
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelDosAdivinanzas'))
                                sessionAttributes.past_wordsNivelDosAdivinanzas = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelDosAdivinanzas = getRandomAdivinanza(sessionAttributes.past_wordsNivelDosAdivinanzas);
                            const pistaTextoDosAdivinanzas = palabraNivelDosAdivinanzas.pistaPalabra;
                            title = palabraNivelDosAdivinanzas.palabra;
                            subtitle = 'Es _';
                            body = `Pista: ${pistaTextoDosAdivinanzas}`;
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelDosAdivinanzas.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`,
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelDosAdivinanzas = palabraNivelDosAdivinanzas;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `${palabraNivelDosAdivinanzas.palabra}`;
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_pistatexto,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        subtitle: subtitle,
                                        body: body,
                                      },
                                    },
                                  });
                               
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } else if (sessionAttributes.nivelAdivinanzas === '3'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelTresAdivinanzas') &&
                                sessionAttributes.current_wordNivelTresAdivinanzas !== null
                            ) {
                                speakOutput = `${sessionAttributes.current_wordNivelTresAdivinanzas.palabra}`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelTresAdivinanzas.palabra}`,
                                        body: 'Es _',
                                      },
                                    },
                                  });
                                
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelTresAdivinanzas'))
                                sessionAttributes.past_wordsNivelTresAdivinanzas = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelTresAdivinanzas = getRandomAdivinanza(sessionAttributes.past_wordsNivelTresAdivinanzas);
                            title = palabraNivelTresAdivinanzas.palabra;
                            body = 'Es _';
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelTresAdivinanzas.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`,
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelTresAdivinanzas = palabraNivelTresAdivinanzas;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `${palabraNivelTresAdivinanzas.palabra}`;
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        body: body,
                                      },
                                    },
                                  });
                                
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } else {
                            
                            speakOutput = 'Error en el nivel'
                        }
                    }
                    
                } else if (res.statusCode === 404) {
                  
                    speakOutput = `Elige un nivel disponible para Las Adivinanzas`;
                    title = 'Elige un nivel disponible';
                    body = 'Nivel 1, 2 o 3';
                    
                    if (
                          Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                            'Alexa.Presentation.APL'
                          ]
                        ) {
                          // add a directive to render our simple template
                          handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                            datasources: {
                              myData: {
                                title: title,
                                body: body,
                              },
                            },
                          });
                    }  

    
                } else if (res.statusCode === 400) {
                  
                    speakOutput = `Solicitud mal formulada`;
                    
                    if (
                          Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                            'Alexa.Presentation.APL'
                          ]
                        ) {
                          // add a directive to render our simple template
                          handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                            datasources: {
                              myData: {
                                title: 'Error 400',
                                body: 'Solicitud mal formulada',
                              },
                            },
                          });
                    } 
                    
                } else {
                          
                        // No se encontró un juego válido
                        speakOutput = 'No se ha podido obtener un juego';
                        
                        if (
                              Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                              ]
                            ) {
                              handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                  myData: {
                                    title: 'Error',
                                    body: 'No se han encontrado datos de juego',
                                  },
                                },
                              });
                            
                            }
                        
                        
                      }
        
                  resolve();
                });
                
              });
    
          req.on('error', error => {
            speakOutput = 'Lo siento, no puedo obtener los detalles de un juego en este momento.';
            if (
                Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                    'Alexa.Presentation.APL'
                ]
                ) {
                    handlerInput.responseBuilder.addDirective({
                        type: 'Alexa.Presentation.APL.RenderDocument',
                        document: APL_simple,
                            datasources: {
                                myData: {
                                    title: 'Error',
                                    body: 'No se pueden obtener los datos',
                                },
                            },
                        });
                    }
            reject();
          });
    
          req.end();
        });

        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
    }
};


const AdivinanzasIntentHandler = {
    
    canHandle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && sessionAttributes.juegoElegido === juegos[2]
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'ContestarPalabraIntent';
            
    },
    
    handle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        const nivelAdivinanzasComparar = sessionAttributes.nivelAdivinanzas;
        
        var speakOutput = '';
        var title = '';
        var subtitle = '';
        var body = '';
        var APL_simple = require('./documents/APL_simple.json');
        var acierto;
        var error;
        var final;
        var duracion;
        var duracionMili;
        
        if (nivelAdivinanzasComparar === '1') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelUnoAdivinanzas') &&
                    sessionAttributes.current_wordNivelUnoAdivinanzas === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelUnoAdivinanzas')
                ) {
                    speakOutput =
                        "Lo siento, no hay una adivinanza. ¿Quieres una?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una adivinanza',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelUnoAdivinanzas = handlerInput.requestEnvelope.request.intent.slots.respuestaPalabra.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelUnoAdivinanzas = require('./functions/comprobar.js');

                const aciertoNivelUnoAdivinanzas = comprobarNivelUnoAdivinanzas.checkAnswer(
                    sessionAttributes.current_wordNivelUnoAdivinanzas,
                    respuesta_usuarioNivelUnoAdivinanzas
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelUnoAdivinanzas.push(sessionAttributes.current_wordNivelUnoAdivinanzas);
                const palabra_mostrarNivelUnoAdivinanzas = sessionAttributes.current_wordNivelUnoAdivinanzas.palabra;
                const palabra_solucionNivelUnoAdivinanzas = sessionAttributes.current_wordNivelUnoAdivinanzas.solucion;
                sessionAttributes.current_wordNivelUnoAdivinanzas = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelUnoAdivinanzas'))
                  sessionAttributes.puntuacionNivelUnoAdivinanzas = 0;

                
                // Comprobación respuesta
                if (aciertoNivelUnoAdivinanzas) {
                    sessionAttributes.puntuacionNivelUnoAdivinanzas += 1;
                    
                    acierto = 1;
                    error = 0;
                    
                    speakOutput = `¡Wow! ¡Adivinaste que ${palabra_solucionNivelUnoAdivinanzas} era la solución de la adivinanza!. 
                    Ahora tu puntuación del nivel 1 es ${sessionAttributes.puntuacionNivelUnoAdivinanzas}. Elige un nivel u otro juego para seguir jugando`;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Enhorabuena!',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... No has encontrado la solución de la adivinanza. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(3, sessionAttributes.idUsuario, duracion, acierto, error, 1)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else if (nivelAdivinanzasComparar === '2') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelDosAdivinanzas') &&
                    sessionAttributes.current_wordNivelDosAdivinanzas === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelDosAdivinanzas')
                ) {
                    speakOutput =
                        "Lo siento, no hay una adivinanza. ¿Quieres una?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una adivinanza',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelDosAdivinanzas = handlerInput.requestEnvelope.request.intent.slots.respuestaPalabra.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelDosAdivinanzas = require('./functions/comprobar.js');

                const aciertoNivelDosAdivinanzas = comprobarNivelDosAdivinanzas.checkAnswer(
                    sessionAttributes.current_wordNivelDosAdivinanzas,
                    respuesta_usuarioNivelDosAdivinanzas
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelDosAdivinanzas.push(sessionAttributes.current_wordNivelDosAdivinanzas);
                const palabra_mostrarNivelDosAdivinanzas = sessionAttributes.current_wordNivelDosAdivinanzas.palabra;
                const palabra_solucionNivelDosAdivinanzas = sessionAttributes.current_wordNivelDosAdivinanzas.solucion;
                sessionAttributes.current_wordNivelDosAdivinanzas = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelDosAdivinanzas'))
                  sessionAttributes.puntuacionNivelDosAdivinanzas = 0;

                
                // Comprobación respuesta
                if (aciertoNivelDosAdivinanzas) {
                    sessionAttributes.puntuacionNivelDosAdivinanzas += 1;
                    
                    acierto = 1;
                    error = 0;
                    
                    speakOutput = `¡Wow! ¡Adivinaste que ${palabra_solucionNivelDosAdivinanzas} era la solución de la adivinanza!. 
                    Ahora tu puntuación del nivel 2 es ${sessionAttributes.puntuacionNivelDosAdivinanzas}. Elige un nivel u otro juego para seguir jugando`;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Enhorabuena!',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... No has encontrado la solución de la adivinanza. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(3, sessionAttributes.idUsuario, duracion, acierto, error, 2)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else if (nivelAdivinanzasComparar === '3') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelTresAdivinanzas') &&
                    sessionAttributes.current_wordNivelTresAdivinanzas === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelTresAdivinanzas')
                ) {
                    speakOutput =
                        "Lo siento, no hay una adivinanza. ¿Quieres una?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una adivinanza',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelTresAdivinanzas = handlerInput.requestEnvelope.request.intent.slots.respuestaPalabra.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelTresAdivinanzas = require('./functions/comprobar.js');

                const aciertoNivelTresAdivinanzas = comprobarNivelTresAdivinanzas.checkAnswer(
                    sessionAttributes.current_wordNivelTresAdivinanzas,
                    respuesta_usuarioNivelTresAdivinanzas
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelTresAdivinanzas.push(sessionAttributes.current_wordNivelTresAdivinanzas);
                const palabra_mostrarNivelTresAdivinanzas = sessionAttributes.current_wordNivelTresAdivinanzas.palabra;
                const palabra_solucionNivelTresAdivinanzas = sessionAttributes.current_wordNivelTresAdivinanzas.solucion;
                sessionAttributes.current_wordNivelTresAdivinanzas = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelTresAdivinanzas'))
                  sessionAttributes.puntuacionNivelTresAdivinanzas = 0;

                
                // Comprobación respuesta
                if (aciertoNivelTresAdivinanzas) {
                    sessionAttributes.puntuacionNivelTresAdivinanzas += 1;
                    
                    acierto = 1;
                    error = 0;
                    
                    speakOutput = `¡Wow! ¡Adivinaste que ${palabra_solucionNivelTresAdivinanzas} era la solución de la adivinanza!. 
                    Ahora tu puntuación del nivel 3 es ${sessionAttributes.puntuacionNivelTresAdivinanzas}. Elige un nivel u otro juego para seguir jugando`;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Enhorabuena!',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... No has encontrado la solución de la adivinanza. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(3, sessionAttributes.idUsuario, duracion, acierto, error, 3)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else {
            
            speakOutput = 'Error de nivel';
            if (
                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                    'Alexa.Presentation.APL'
                    ]
                    ) {
                        handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                            datasources: {
                                  myData: {
                                    title: 'Error',
                                    body: 'No se han encontrado datos de juego',
                                  },
                                },
                              });
                            
                            }
            
        }
        
        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
        
    }
    
};


const SilabaOcultaHandler = {
    canHandle(handlerInput) {

        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && sessionAttributes.juegoElegido === juegos[3]
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'SeleccionarNivelIntent'
    },
    
    async handle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        var nivelOculta = handlerInput.requestEnvelope.request.intent.slots.numNivel.value;
        
        var speakOutput = '';
        var title = '';
        var subtitle = '';
        var body = '';
        var foto = '';
        var inicio;
        var APL_pistatexto = require('./documents/APL_pistatexto.json');
        var APL_simple = require('./documents/APL_simple.json');
        var APL_pistafototexto = require('./documents/APL_pistafototexto.json');
        
        if (nivelOculta !== "1") {
            
            // No se encontró un juego válido
            speakOutput = 'Elige un nivel disponible para La Sílaba Oculta';
                            
            if (
                Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                    'Alexa.Presentation.APL'
                ]
                ) {
                    handlerInput.responseBuilder.addDirective({
                        type: 'Alexa.Presentation.APL.RenderDocument',
                        document: APL_simple,
                        datasources: {
                        myData: {
                            title: 'Elige un nivel disponible',
                            body: 'Nivel 1',
                        },
                        },
                        });
                                
                }
            
            
        } else {

            const options = {
              hostname: 'www.it.uniovi.es',
              port: 443,
              path: `/hosesbackend/skillTrastornosLectura.php?idSkill=c7800aee8f9287a60ffe835984a38431&idActividad=4&nivelActividad=1`,
              method: 'GET',
              auth: 'lfonteriz:aaa1674unTFG',
              headers: {
                'Content-Type': 'application/json'
              }
            };
        
            await new Promise((resolve, reject) => {
              const req = https.request(options, res => {
                res.setEncoding('utf8');
                let responseData = '';
        
                res.on('data', chunk => {
                  responseData += chunk;
                });
        
                res.on('end', () => {
                    
                    if (res.statusCode === 200) {
                        
                        const juegosTodo = JSON.parse(responseData);
                  
                        const getRandomOculta = function(pastPalabras = []) {
                          const filtrado = Object.values(juegosTodo).filter(p => !pastPalabras.find(pp => pp.objid === p.objid));
                          
                          return filtrado.length > 0
                            ? filtrado[Math.floor(Math.random() * filtrado.length)]
                            : {"objid": 0, "palabra": null, "solucion": null};
                        };
                        
                        if (juegosTodo) {
                            
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                                if (
                                    sessionAttributes.hasOwnProperty('current_wordOculta') &&
                                    sessionAttributes.current_wordOculta !== null
                                ) {
                                    speakOutput = `¿Qué palabra se esconde en ${sessionAttributes.current_wordOculta.palabra}?`;
                                    
                                    if (
                                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                        'Alexa.Presentation.APL'
                                      ]
                                    ) {
                                      handlerInput.responseBuilder.addDirective({
                                        type: 'Alexa.Presentation.APL.RenderDocument',
                                        document: APL_pistafototexto,
                                        datasources: {
                                          myData: {
                                            title: `${sessionAttributes.current_wordOculta.palabra}`,
                                            subtitle: 'Es _',
                                            foto: `${sessionAttributes.current_wordOculta.pistaFoto}`,
                                          },
                                        },
                                      });
        
                                    }
                        
                                    return handlerInput.responseBuilder
                                        .speak(speakOutput)
                                        .reprompt(speakOutput)
                                        .getResponse();
                                    }
                                
                                // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                                
                                if (!sessionAttributes.hasOwnProperty('past_wordsOculta'))
                                    sessionAttributes.past_wordsOculta = [];
                                
                                // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                                const palabraOculta = getRandomOculta(sessionAttributes.past_wordsOculta);
                                const pistaFotoOculta = palabraOculta.pistaFoto;
                                title = palabraOculta.palabra;
                                subtitle = 'Es _';
                                foto = pistaFotoOculta;
                                
                                // Comprobamos si queda alguna palabra
                                if (palabraOculta.objid === 0) {
                                    
                                    speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                    
                                    if (
                                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                        'Alexa.Presentation.APL'
                                      ]
                                    ) {
                                      handlerInput.responseBuilder.addDirective({
                                        type: 'Alexa.Presentation.APL.RenderDocument',
                                        document: APL_simple,
                                        datasources: {
                                          myData: {
                                            title: 'ENHORABUENA',
                                            body: `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`,
                                          },
                                        },
                                      });
                                    
                                    }
                                    
                                } else {
                                    // Configuramos el atributo current_word
                                    sessionAttributes.current_wordOculta = palabraOculta;
                                
                                    // Guardamos los atributos de sesión
                                    handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                                
                                    // Hacemos la pregunta
                                    speakOutput = `¿Qué palabra se esconde en ${sessionAttributes.current_wordOculta.palabra}?`;
                                    if (
                                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                        'Alexa.Presentation.APL'
                                      ]
                                    ) {
                                      handlerInput.responseBuilder.addDirective({
                                        type: 'Alexa.Presentation.APL.RenderDocument',
                                        document: APL_pistafototexto,
                                        datasources: {
                                          myData: {
                                            title: title,
                                            subtitle: subtitle,
                                            foto: foto,
                                          },
                                        },
                                      });
        
                                    }
                                    
                                    // Creamos timestamp de inicio 
                                    inicio = new Date();
                                    sessionAttributes.timestampInicio = inicio.getTime();
                                    handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                }
                            
                        } 
                        
                    } else if (res.statusCode === 404) {
                      
                        speakOutput = `Elige un nivel disponible para La Sílaba Oculta`;
                        title = 'Elige un nivel disponible';
                        body = 'Nivel 1';
                        
                        if (
                              Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                              ]
                            ) {
                              // add a directive to render our simple template
                              handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                  myData: {
                                    title: title,
                                    body: body,
                                  },
                                },
                              });
                        }  
    
        
                    } else if (res.statusCode === 400) {
                      
                        speakOutput = `Solicitud mal formulada`;
                        
                        if (
                              Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                              ]
                            ) {
                              // add a directive to render our simple template
                              handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                  myData: {
                                    title: 'Error 400',
                                    body: 'Solicitud mal formulada',
                                  },
                                },
                              });
                        } 
                        
                    } else {
                              
                            // No se encontró un juego válido
                            speakOutput = 'No se ha podido obtener un juego';
                            
                            if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'Error',
                                        body: 'No se han encontrado datos de juego',
                                      },
                                    },
                                  });
                                
                                }
                            
                            
                          }
            
                      resolve();
                    });
                    
                  });
                  
              req.on('error', error => {
                speakOutput = 'Lo siento, no puedo obtener los detalles de un juego en este momento.';
                if (
                    Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                    ]
                    ) {
                        handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                                datasources: {
                                    myData: {
                                        title: 'Error',
                                        body: 'No se pueden obtener los datos',
                                    },
                                },
                            });
                        }
        
                reject();
              });
        
              req.end();
            });
            
        }

        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
    }
};


const SilabaOcultaIntentHandler = {
    
    canHandle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && sessionAttributes.juegoElegido === juegos[3]
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'ContestarPalabraIntent';
            
    },
    
    handle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        var speakOutput = '';
        var title = '';
        var subtitle = '';
        var body = '';
        var APL_simple = require('./documents/APL_simple.json');
        var acierto;
        var error;
        var final;
        var duracion;
        var duracionMili;
        
        // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordOculta') &&
                    sessionAttributes.current_wordOculta === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordOculta')
                ) {
                    speakOutput =
                        "Lo siento, no hay una palabra para encontrar su sílaba oculta. ¿Quieres una palabra?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una palabra para encontrar su sílaba oculta',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioOculta = handlerInput.requestEnvelope.request.intent.slots.respuestaPalabra.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarOculta = require('./functions/comprobar.js');

                const aciertoOculta = comprobarOculta.checkAnswer(
                    sessionAttributes.current_wordOculta,
                    respuesta_usuarioOculta
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsOculta.push(sessionAttributes.current_wordOculta);
                const palabra_mostrarOculta = sessionAttributes.current_wordOculta.palabra;
                const palabra_solucionOculta = sessionAttributes.current_wordOculta.solucion;
                sessionAttributes.current_wordOculta = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionOculta'))
                  sessionAttributes.puntuacionOculta = 0;

                
                // Comprobación respuesta
                if (aciertoOculta) {
                    sessionAttributes.puntuacionOculta += 1;
                    
                    acierto = 1;
                    error = 0;
                    
                    speakOutput = `¡Wow! ¡Adivinaste que ${palabra_solucionOculta} se escondía en ${palabra_mostrarOculta}. 
                    Ahora tu puntuación es ${sessionAttributes.puntuacionOculta}. Elige un nivel u otro juego para seguir jugando`;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Enhorabuena!',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... No has adivinado qué palabra se escondía en ${palabra_mostrarOculta}. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(4, sessionAttributes.idUsuario, duracion, acierto, error, 1)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
        
        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
        
    }
    
};


const AntonimosHandler = {
    canHandle(handlerInput) {

        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && sessionAttributes.juegoElegido === juegos[4]
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'SeleccionarNivelIntent'
    },
    
    async handle(handlerInput) {
        const nivel = handlerInput.requestEnvelope.request.intent.slots.numNivel.value;
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        sessionAttributes.nivelAntonimos = nivel;
        
        var speakOutput = '';
        var title = '';
        var subtitle = '';
        var body = '';
        var foto = '';
        var inicio;
        var APL_simple = require('./documents/APL_simple.json');
        var APL_pistafototexto = require('./documents/APL_pistafototexto.json');
        
        const options = {
          hostname: 'www.it.uniovi.es',
          port: 443,
          path: `/hosesbackend/skillTrastornosLectura.php?idSkill=c7800aee8f9287a60ffe835984a38431&idActividad=5&nivelActividad=${sessionAttributes.nivelAntonimos}`,
          method: 'GET',
          auth: 'lfonteriz:aaa1674unTFG',
          headers: {
            'Content-Type': 'application/json'
          }
        };
    
        await new Promise((resolve, reject) => {
          const req = https.request(options, res => {
            res.setEncoding('utf8');
            let responseData = '';
    
            res.on('data', chunk => {
              responseData += chunk;
            });
    
            res.on('end', () => {
                
                if (res.statusCode === 200) {
                    
                    const juegosTodo = JSON.parse(responseData);
              
                    const getRandomAntonimo = function(pastPalabras = []) {
                      const filtrado = Object.values(juegosTodo).filter(p => !pastPalabras.find(pp => pp.objid === p.objid));
                      
                      return filtrado.length > 0
                        ? filtrado[Math.floor(Math.random() * filtrado.length)]
                        : {"objid": 0, "palabra": null, "solucion": null};
                    };
                    
                    if (juegosTodo) {
                          
                        if (sessionAttributes.nivelAntonimos === '1'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelUnoAntonimos') &&
                                sessionAttributes.current_wordNivelUnoAntonimos !== null
                            ) {
                                speakOutput = `¿Cuál es el antónimo de ${sessionAttributes.current_wordNivelUnoAntonimos.palabra}?`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_pistafototexto,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelUnoAntonimos.palabra}`,
                                        subtitle: 'Su antónimo es _',
                                        foto: `${sessionAttributes.current_wordNivelUnoAntonimos.pistaFoto}`,
                                      },
                                    },
                                  });
    
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelUnoAntonimos'))
                                sessionAttributes.past_wordsNivelUnoAntonimos = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelUnoAntonimos = getRandomAntonimo(sessionAttributes.past_wordsNivelUnoAntonimos);
                            const pistaFotoUnoAntonimos = palabraNivelUnoAntonimos.pistaFoto;
                            title = palabraNivelUnoAntonimos.palabra;
                            subtitle = 'Su antónimo es _';
                            foto = pistaFotoUnoAntonimos;
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelUnoAntonimos.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`,
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelUnoAntonimos = palabraNivelUnoAntonimos;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `¿Cuál es el antónimo de ${palabraNivelUnoAntonimos.palabra}?`;
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_pistafototexto,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        subtitle: subtitle,
                                        foto: foto,
                                      },
                                    },
                                  });
    
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
    
                            }
                          
                        } else if (sessionAttributes.nivelAntonimos === '2'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelDosAntonimos') &&
                                sessionAttributes.current_wordNivelDosAntonimos !== null
                            ) {
                                speakOutput = `¿Cuál es el antónimo de ${sessionAttributes.current_wordNivelDosAntonimos.palabra}?`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelDosAntonimos.palabra}`,
                                        body: 'Su antónimo es _',
                                      },
                                    },
                                  });
    
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelDosAntonimos'))
                                sessionAttributes.past_wordsNivelDosAntonimos = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelDosAntonimos = getRandomAntonimo(sessionAttributes.past_wordsNivelDosAntonimos);
                            title = palabraNivelDosAntonimos.palabra;
                            body = 'Su antónimo es _';
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelDosAntonimos.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`,
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelDosAntonimos = palabraNivelDosAntonimos;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `¿Cuál es el antónimo de ${palabraNivelDosAntonimos.palabra}?`;
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        body: body,
                                      },
                                    },
                                  });
    
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } 
                    }
                    
                } else if (res.statusCode === 404) {
                  
                    speakOutput = `Elige un nivel disponible para Los Antónimos`;
                    title = 'Elige un nivel disponible';
                    body = 'Nivel 1 o 2';
                    
                    if (
                          Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                            'Alexa.Presentation.APL'
                          ]
                        ) {
                          // add a directive to render our simple template
                          handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                            datasources: {
                              myData: {
                                title: title,
                                body: body,
                              },
                            },
                          });
                    }  

    
                } else if (res.statusCode === 400) {
                  
                    speakOutput = `Solicitud mal formulada`;
                    
                    if (
                          Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                            'Alexa.Presentation.APL'
                          ]
                        ) {
                          // add a directive to render our simple template
                          handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                            datasources: {
                              myData: {
                                title: 'Error 400',
                                body: 'Solicitud mal formulada',
                              },
                            },
                          });
                    } 
                    
                } else {
                          
                        // No se encontró un juego válido
                        speakOutput = 'No se ha podido obtener un juego';
                        
                        if (
                              Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                              ]
                            ) {
                              handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                  myData: {
                                    title: 'Error',
                                    body: 'No se han encontrado datos de juego',
                                  },
                                },
                              });
                            
                            }
                        
                        
                      }
        
                  resolve();
                });
                
              });
    
          req.on('error', error => {
            speakOutput = 'Lo siento, no puedo obtener los detalles de un juego en este momento.';
            
            if (
                Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                    'Alexa.Presentation.APL'
                ]
                ) {
                    handlerInput.responseBuilder.addDirective({
                        type: 'Alexa.Presentation.APL.RenderDocument',
                        document: APL_simple,
                            datasources: {
                                myData: {
                                    title: 'Error',
                                    body: 'No se pueden obtener los datos',
                                },
                            },
                        });
                    }
    
            reject();
          });
    
          req.end();
        });
        
        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
    }
};


const AntonimosIntentHandler = {
    
    canHandle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && sessionAttributes.juegoElegido === juegos[4]
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'ContestarAntonimosIntent';
            
    },
    
    handle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        const nivelAntonimosComparar = sessionAttributes.nivelAntonimos;
        
        var speakOutput = '';
        var title = '';
        var subtitle = '';
        var body = '';
        var APL_simple = require('./documents/APL_simple.json');
        var acierto;
        var error;
        var final;
        var duracion;
        var duracionMili;
        
        if (nivelAntonimosComparar === '1') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelUnoAntonimos') &&
                    sessionAttributes.current_wordNivelUnoAntonimos === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelUnoAntonimos')
                ) {
                    speakOutput =
                        "Lo siento, no hay una palabra para encontrar su antónimo ahora mismo. ¿Quieres una palabra?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una palabra para encontrar su antónimo',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelUnoAntonimos = handlerInput.requestEnvelope.request.intent.slots.antonimo.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelUnoAntonimos = require('./functions/comprobar.js');

                const aciertoNivelUnoAntonimos = comprobarNivelUnoAntonimos.checkAnswer(
                    sessionAttributes.current_wordNivelUnoAntonimos,
                    respuesta_usuarioNivelUnoAntonimos
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelUnoAntonimos.push(sessionAttributes.current_wordNivelUnoAntonimos);
                const palabra_mostrarNivelUnoAntonimos = sessionAttributes.current_wordNivelUnoAntonimos.palabra;
                const palabra_solucionNivelUnoAntonimos = sessionAttributes.current_wordNivelUnoAntonimos.solucion;
                sessionAttributes.current_wordNivelUnoAntonimos = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelUnoAntonimos'))
                  sessionAttributes.puntuacionNivelUnoAntonimos = 0;

                
                // Comprobación respuesta
                if (aciertoNivelUnoAntonimos) {
                    sessionAttributes.puntuacionNivelUnoAntonimos += 1;
                    
                    acierto = 1;
                    error = 0;
                    
                    speakOutput = `¡Wow! ¡Adivinaste que ${palabra_solucionNivelUnoAntonimos} era el antónimo de ${palabra_mostrarNivelUnoAntonimos}. 
                    Ahora tu puntuación del nivel 1 es ${sessionAttributes.puntuacionNivelUnoAntonimos}. Elige un nivel u otro juego para seguir jugando`;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Enhorabuena!',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... No has adivinado el antónimo de ${palabra_mostrarNivelUnoAntonimos}. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(5, sessionAttributes.idUsuario, duracion, acierto, error, 1)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else if (nivelAntonimosComparar === '2') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelDosAntonimos') &&
                    sessionAttributes.current_wordNivelDosAntonimos === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelDosAntonimos')
                ) {
                    speakOutput =
                        "Lo siento, no hay una palabra para encontrar su antónimo ahora mismo. ¿Quieres una palabra?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una palabra para encontrar su antónimo',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelDosAntonimos = handlerInput.requestEnvelope.request.intent.slots.antonimo.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelDosAntonimos = require('./functions/comprobar.js');

                const aciertoNivelDosAntonimos = comprobarNivelDosAntonimos.checkAnswer(
                    sessionAttributes.current_wordNivelDosAntonimos,
                    respuesta_usuarioNivelDosAntonimos
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelDosAntonimos.push(sessionAttributes.current_wordNivelDosAntonimos);
                const palabra_mostrarNivelDosAntonimos = sessionAttributes.current_wordNivelDosAntonimos.palabra;
                const palabra_solucionNivelDosAntonimos = sessionAttributes.current_wordNivelDosAntonimos.solucion;
                sessionAttributes.current_wordNivelDosAntonimos = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelDosAntonimos'))
                  sessionAttributes.puntuacionNivelDosAntonimos = 0;

                
                // Comprobación respuesta
                if (aciertoNivelDosAntonimos) {
                    sessionAttributes.puntuacionNivelDosAntonimos += 1;
                    
                    acierto = 1;
                    error = 0;
                    
                    speakOutput = `¡Wow! ¡Adivinaste que ${palabra_solucionNivelDosAntonimos} era el antónimo de ${palabra_mostrarNivelDosAntonimos}. 
                    Ahora tu puntuación del nivel 2 es ${sessionAttributes.puntuacionNivelDosAntonimos}. Elige un nivel u otro juego para seguir jugando`;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Enhorabuena!',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... No has adivinado el antónimo de ${palabra_mostrarNivelDosAntonimos}. Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(5, sessionAttributes.idUsuario, duracion, acierto, error, 2)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else {
            
            speakOutput = 'Error de nivel';
            if (
                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                    'Alexa.Presentation.APL'
                    ]
                    ) {
                        handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                            datasources: {
                                  myData: {
                                    title: 'Error',
                                    body: 'No se han encontrado datos de juego',
                                  },
                                },
                              });
                            
                            }
            
        }
        
        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
        
    }
    
};


const RepitePalabraHandler = {
    canHandle(handlerInput) {

        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && sessionAttributes.juegoElegido === juegos[5]
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'SeleccionarNivelIntent'
    },
    
    async handle(handlerInput) {
        const nivel = handlerInput.requestEnvelope.request.intent.slots.numNivel.value;
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        sessionAttributes.nivelRepetirPalabra = nivel;
        
        var speakOutput = '';
        var title = '';
        var subtitle = '';
        var body = '';
        var foto = '';
        var inicio;
        var APL_simple = require('./documents/APL_simple.json');
        
        const options = {
          hostname: 'www.it.uniovi.es',
          port: 443,
          path: `/hosesbackend/skillTrastornosLectura.php?idSkill=c7800aee8f9287a60ffe835984a38431&idActividad=6&nivelActividad=${sessionAttributes.nivelRepetirPalabra}`,
          method: 'GET',
          auth: 'lfonteriz:aaa1674unTFG',
          headers: {
            'Content-Type': 'application/json'
          }
        };
    
        await new Promise((resolve, reject) => {
          const req = https.request(options, res => {
            res.setEncoding('utf8');
            let responseData = '';
    
            res.on('data', chunk => {
              responseData += chunk;
            });
    
            res.on('end', () => {
                
                if (res.statusCode === 200) {
                    
                    const juegosTodo = JSON.parse(responseData);
              
                    const getRandomRepetir = function(pastPalabras = []) {
                      const filtrado = Object.values(juegosTodo).filter(p => !pastPalabras.find(pp => pp.objid === p.objid));
                      
                      return filtrado.length > 0
                        ? filtrado[Math.floor(Math.random() * filtrado.length)]
                        : {"objid": 0, "palabra": null, "solucion": null};
                    };
                    
                    if (juegosTodo) {
                          
                        if (sessionAttributes.nivelRepetirPalabra === '1'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelUnoRepetir') &&
                                sessionAttributes.current_wordNivelUnoRepetir !== null
                            ) {
                                speakOutput = `Repite la palabra: ${sessionAttributes.current_wordNivelUnoRepetir.palabra}`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelUnoRepetir.palabra}`,
                                        body: 'Es _',
                                      },
                                    },
                                  });
                                
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelUnoRepetir'))
                                sessionAttributes.past_wordsNivelUnoRepetir = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelUnoRepetir = getRandomRepetir(sessionAttributes.past_wordsNivelUnoRepetir);
                            title = palabraNivelUnoRepetir.palabra;
                            body = 'Es _';
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelUnoRepetir.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`,
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelUnoRepetir = palabraNivelUnoRepetir;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `Repite la palabra: ${sessionAttributes.current_wordNivelUnoRepetir.palabra}`;
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        body: body,
                                      },
                                    },
                                  });
                                
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } else if (sessionAttributes.nivelRepetirPalabra === '2'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelDosRepetir') &&
                                sessionAttributes.current_wordNivelDosRepetir !== null
                            ) {
                                speakOutput = `Repite la palabra: ${sessionAttributes.current_wordNivelDosRepetir.palabra}`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelDosRepetir.palabra}`,
                                        body: 'Es _',
                                      },
                                    },
                                  });
    
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelDosRepetir'))
                                sessionAttributes.past_wordsNivelDosRepetir = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelDosRepetir = getRandomRepetir(sessionAttributes.past_wordsNivelDosRepetir);
                            title = palabraNivelDosRepetir.palabra;
                            body = 'Es _';
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelDosRepetir.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`,
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelDosRepetir = palabraNivelDosRepetir;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `Repite la palabra: ${sessionAttributes.current_wordNivelDosRepetir.palabra}`;
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        body: body,
                                      },
                                    },
                                  });
    
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } else if (sessionAttributes.nivelRepetirPalabra === '3'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelTresRepetir') &&
                                sessionAttributes.current_wordNivelTresRepetir !== null
                            ) {
                                speakOutput = `Repite la palabra: ${sessionAttributes.current_wordNivelTresRepetir.palabra}`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelTresRepetir.palabra}`,
                                        body: 'Es _',
                                      },
                                    },
                                  });
                                
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelTresRepetir'))
                                sessionAttributes.past_wordsNivelTresRepetir = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelTresRepetir = getRandomRepetir(sessionAttributes.past_wordsNivelTresRepetir);
                            title = palabraNivelTresRepetir.palabra;
                            body = 'Es _';
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelTresRepetir.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`,
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelTresRepetir = palabraNivelTresRepetir;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `Repite la palabra: ${sessionAttributes.current_wordNivelTresRepetir.palabra}`;
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        body: body,
                                      },
                                    },
                                  });
                                
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } else if (sessionAttributes.nivelRepetirPalabra === '4'){
                
                            // Comprobamos si hay palabra actual. Si la hay, repetimos la pregunta y salimos
                            if (
                                sessionAttributes.hasOwnProperty('current_wordNivelCuatroRepetir') &&
                                sessionAttributes.current_wordNivelCuatroRepetir !== null
                            ) {
                                speakOutput = `Repite la palabra: ${sessionAttributes.current_wordNivelCuatroRepetir.palabra}`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: `${sessionAttributes.current_wordNivelCuatroRepetir.palabra}`,
                                        body: 'Es _',
                                      },
                                    },
                                  });
                                
                                }
                    
                                return handlerInput.responseBuilder
                                    .speak(speakOutput)
                                    .reprompt(speakOutput)
                                    .getResponse();
                                }
                            
                            // Comprueba si hay una matriz de palabras anteriores y créala si no está disponible
                            
                            if (!sessionAttributes.hasOwnProperty('past_wordsNivelCuatroRepetir'))
                                sessionAttributes.past_wordsNivelCuatroRepetir = [];
                            
                            // Importamos las funciones de ordenar sílabas y pedimos una palabra aleatoria
                            const palabraNivelCuatroRepetir = getRandomRepetir(sessionAttributes.past_wordsNivelCuatroRepetir);
                            title = palabraNivelCuatroRepetir.palabra;
                            body = 'Es _';
                            
                            // Comprobamos si queda alguna palabra
                            if (palabraNivelCuatroRepetir.objid === 0) {
                                
                                speakOutput = `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`;
                                
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: 'ENHORABUENA',
                                        body: `¡Te has pasado el juego! Elige un nivel u otro juego para seguir jugando`,
                                      },
                                    },
                                  });
                                
                                }
                                
                            } else {
                                // Configuramos el atributo current_word
                                sessionAttributes.current_wordNivelCuatroRepetir = palabraNivelCuatroRepetir;
                            
                                // Guardamos los atributos de sesión
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                            
                                // Hacemos la pregunta
                                speakOutput = `Repite la palabra: ${sessionAttributes.current_wordNivelCuatroRepetir.palabra}`;
                                if (
                                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                    'Alexa.Presentation.APL'
                                  ]
                                ) {
                                  handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                    datasources: {
                                      myData: {
                                        title: title,
                                        body: body,
                                      },
                                    },
                                  });
                                
                                }
                                
                                // Creamos timestamp de inicio 
                                inicio = new Date();
                                sessionAttributes.timestampInicio = inicio.getTime();
                                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                        
                            }
                          
                        } 
                        
                    }
                } else if (res.statusCode === 404) {
                  
                    speakOutput = `Elige un nivel disponible para Repite la Palabra`;
                    title = 'Elige un nivel disponible';
                    body = 'Nivel 1 (letra L), 2 (letra R), 3 (letra S) o 4 (letra D)';
                    
                    if (
                          Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                            'Alexa.Presentation.APL'
                          ]
                        ) {
                          // add a directive to render our simple template
                          handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                            datasources: {
                              myData: {
                                title: title,
                                body: body,
                              },
                            },
                          });
                    }  

    
                } else if (res.statusCode === 400) {
                  
                    speakOutput = `Solicitud mal formulada`;
                    
                    if (
                          Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                            'Alexa.Presentation.APL'
                          ]
                        ) {
                          // add a directive to render our simple template
                          handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                            datasources: {
                              myData: {
                                title: 'Error 400',
                                body: 'Solicitud mal formulada',
                              },
                            },
                          });
                    } 
                    
                } else {
                          
                        // No se encontró un juego válido
                        speakOutput = 'No se ha podido obtener un juego';
                        
                        if (
                              Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                              ]
                            ) {
                              handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                  myData: {
                                    title: 'Error',
                                    body: 'No se han encontrado datos de juego',
                                  },
                                },
                              });
                            
                            }
                        
                        
                      }
        
                  resolve();
                });
                
              });
    
          req.on('error', error => {
            speakOutput = 'Lo siento, no puedo obtener los detalles de un juego en este momento.';
            if (
                Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                    'Alexa.Presentation.APL'
                ]
                ) {
                    handlerInput.responseBuilder.addDirective({
                        type: 'Alexa.Presentation.APL.RenderDocument',
                        document: APL_simple,
                            datasources: {
                                myData: {
                                    title: 'Error',
                                    body: 'No se pueden obtener los datos',
                                },
                            },
                        });
                    }
            reject();
          });
    
          req.end();
        });
        
        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
    }
};


const RepitePalabraIntentHandler = {
    
    canHandle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && sessionAttributes.juegoElegido === juegos[5]
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'ContestarPalabraIntent';
            
    },
    
    handle(handlerInput) {
        
        const sessionAttributes = handlerInput.attributesManager.getSessionAttributes();
        const nivelRepetirComparar = sessionAttributes.nivelRepetirPalabra;
        
        var speakOutput = '';
        var title = '';
        var subtitle = '';
        var body = '';
        var APL_simple = require('./documents/APL_simple.json');
        var acierto;
        var error;
        var final;
        var duracion;
        var duracionMili;
        
        if (nivelRepetirComparar === '1') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelUnoRepetir') &&
                    sessionAttributes.current_wordNivelUnoRepetir === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelUnoRepetir')
                ) {
                    speakOutput =
                        "Lo siento, no hay una palabra para repetir. ¿Quieres una palabra?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una palabra para repetir',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelUnoRepetir = handlerInput.requestEnvelope.request.intent.slots.respuestaPalabra.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelUnoRepetir = require('./functions/comprobar.js');

                const aciertoNivelUnoRepetir = comprobarNivelUnoRepetir.checkAnswer(
                    sessionAttributes.current_wordNivelUnoRepetir,
                    respuesta_usuarioNivelUnoRepetir
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelUnoRepetir.push(sessionAttributes.current_wordNivelUnoRepetir);
                const palabra_mostrarNivelUnoRepetir = sessionAttributes.current_wordNivelUnoRepetir.palabra;
                const palabra_solucionNivelUnoRepetir = sessionAttributes.current_wordNivelUnoRepetir.solucion;
                sessionAttributes.current_wordNivelUnoRepetir = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelUnoRepetir'))
                  sessionAttributes.puntuacionNivelUnoRepetir = 0;

                
                // Comprobación respuesta
                if (aciertoNivelUnoRepetir) {
                    sessionAttributes.puntuacionNivelUnoRepetir += 1;
                    
                    acierto = 1;
                    error = 0;
                    
                    speakOutput = `¡Genial! Ahora tu puntuación con la letra L es ${sessionAttributes.puntuacionNivelUnoRepetir}. Elige un nivel u otro juego para seguir jugando`;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Genial!',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(6, sessionAttributes.idUsuario, duracion, acierto, error, 1)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else if (nivelRepetirComparar === '2') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelDosRepetir') &&
                    sessionAttributes.current_wordNivelDosRepetir === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelDosRepetir')
                ) {
                    speakOutput =
                        "Lo siento, no hay una palabra para repetir. ¿Quieres una palabra?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una palabra para repetir',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelDosRepetir = handlerInput.requestEnvelope.request.intent.slots.respuestaPalabra.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelDosRepetir = require('./functions/comprobar.js');

                const aciertoNivelDosRepetir = comprobarNivelDosRepetir.checkAnswer(
                    sessionAttributes.current_wordNivelDosRepetir,
                    respuesta_usuarioNivelDosRepetir
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelDosRepetir.push(sessionAttributes.current_wordNivelDosRepetir);
                const palabra_mostrarNivelDosRepetir = sessionAttributes.current_wordNivelDosRepetir.palabra;
                const palabra_solucionNivelDosRepetir = sessionAttributes.current_wordNivelDosRepetir.solucion;
                sessionAttributes.current_wordNivelDosRepetir = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelDosRepetir'))
                  sessionAttributes.puntuacionNivelDosRepetir = 0;

                
                // Comprobación respuesta
                if (aciertoNivelDosRepetir) {
                    sessionAttributes.puntuacionNivelDosRepetir += 1;
                    
                    acierto = 1;
                    error = 0;
                    
                    speakOutput = `¡Genial! Ahora tu puntuación con la letra R es ${sessionAttributes.puntuacionNivelDosRepetir}. Elige un nivel u otro juego para seguir jugando`;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Genial!',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(6, sessionAttributes.idUsuario, duracion, acierto, error, 2)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else if (nivelRepetirComparar === '3') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelTresRepetir') &&
                    sessionAttributes.current_wordNivelTresRepetir === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelTresRepetir')
                ) {
                    speakOutput =
                        "Lo siento, no hay una palabra para repetir. ¿Quieres una palabra?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una palabra para repetir',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelTresRepetir = handlerInput.requestEnvelope.request.intent.slots.respuestaPalabra.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelTresRepetir = require('./functions/comprobar.js');

                const aciertoNivelTresRepetir = comprobarNivelTresRepetir.checkAnswer(
                    sessionAttributes.current_wordNivelTresRepetir,
                    respuesta_usuarioNivelTresRepetir
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelTresRepetir.push(sessionAttributes.current_wordNivelTresRepetir);
                const palabra_mostrarNivelTresRepetir = sessionAttributes.current_wordNivelTresRepetir.palabra;
                const palabra_solucionNivelTresRepetir = sessionAttributes.current_wordNivelTresRepetir.solucion;
                sessionAttributes.current_wordNivelTresRepetir = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelTresRepetir'))
                  sessionAttributes.puntuacionNivelTresRepetir = 0;

                
                // Comprobación respuesta
                if (aciertoNivelTresRepetir) {
                    sessionAttributes.puntuacionNivelTresRepetir += 1;
                    
                    acierto = 1;
                    error = 0;
                    
                    speakOutput = `¡Genial! Ahora tu puntuación con la letra S es ${sessionAttributes.puntuacionNivelTresRepetir}. Elige un nivel u otro juego para seguir jugando`;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Genial!',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(6, sessionAttributes.idUsuario, duracion, acierto, error, 3)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else if (nivelRepetirComparar === '4') {
            
            // Si hay una palabra actual pero es nula, o no hay una: Error, indícales que digan "sí" y termina
                if ((
                    sessionAttributes.hasOwnProperty('current_wordNivelCuatroRepetir') &&
                    sessionAttributes.current_wordNivelCuatroRepetir === null) ||
                  !sessionAttributes.hasOwnProperty('current_wordNivelCuatroRepetir')
                ) {
                    speakOutput =
                        "Lo siento, no hay una palabra para repetir. ¿Quieres una palabra?";
                        
                        if (
                            Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                                'Alexa.Presentation.APL'
                            ]
                            ) {
                                handlerInput.responseBuilder.addDirective({
                                    type: 'Alexa.Presentation.APL.RenderDocument',
                                    document: APL_simple,
                                        datasources: {
                                            myData: {
                                                title: 'No hay una palabra para repetir',
                                                body: '¿Quieres una?',
                                            },
                                        },
                                    });
                                }
                        
                    return handlerInput.responseBuilder
                        .speak(speakOutput)
                        .reprompt(speakOutput)
                        .getResponse();
                }
            
                // Obtenemos la palabra dicha por el usuario
                var respuesta_usuarioNivelCuatroRepetir = handlerInput.requestEnvelope.request.intent.slots.respuestaPalabra.value;
                final = new Date();
                sessionAttributes.timestampFinal = final.getTime();
                duracionMili = sessionAttributes.timestampFinal - sessionAttributes.timestampInicio;
                duracion = Math.floor(duracionMili / 1000);
                
                // Comprobamos la respuesta
                const comprobarNivelCuatroRepetir = require('./functions/comprobar.js');

                const aciertoNivelCuatroRepetir = comprobarNivelCuatroRepetir.checkAnswer(
                    sessionAttributes.current_wordNivelCuatroRepetir,
                    respuesta_usuarioNivelCuatroRepetir
                );
        
                // Añadimos la palabra a la lista de palabras que ya aparecieron
                // Almacenamos el valor para el resto de la función y cambiamos la palabra actual a null
                sessionAttributes.past_wordsNivelCuatroRepetir.push(sessionAttributes.current_wordNivelCuatroRepetir);
                const palabra_mostrarNivelCuatroRepetir = sessionAttributes.current_wordNivelCuatroRepetir.palabra;
                const palabra_solucionNivelCuatroRepetir = sessionAttributes.current_wordNivelCuatroRepetir.solucion;
                sessionAttributes.current_wordNivelCuatroRepetir = null;
                
                // Comprobamos si hay puntuación y si no la inicializamos
                if (!sessionAttributes.hasOwnProperty('puntuacionNivelCuatroRepetir'))
                  sessionAttributes.puntuacionNivelCuatroRepetir = 0;

                
                // Comprobación respuesta
                if (aciertoNivelCuatroRepetir) {
                    sessionAttributes.puntuacionNivelCuatroRepetir += 1;
                    
                    acierto = 1;
                    error = 0;
                    
                    speakOutput = `¡Genial! Ahora tu puntuación con la letra D es ${sessionAttributes.puntuacionNivelCuatroRepetir}. Elige un nivel u otro juego para seguir jugando`;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: '¡Genial!',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
        
                } else {

                    speakOutput = `Vaya... Elige un nivel u otro juego para seguir jugando`;
                    
                    acierto = 0;
                    error = 1;
                    
                    if (
                      Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                        'Alexa.Presentation.APL'
                        ]
                        ) {
                            handlerInput.responseBuilder.addDirective({
                                type: 'Alexa.Presentation.APL.RenderDocument',
                                document: APL_simple,
                                datasources: {
                                      myData: {
                                        title: 'Oh, vaya',
                                        body: 'Elige un nivel u otro juego para seguir jugando',
                                      },
                                    },
                                  });
                                
                                }
                    
                }
                
                // Almacenamos y actualizamos los datos de la sesión
                handlerInput.attributesManager.setSessionAttributes(sessionAttributes);
                const servidor = require('./functions/servidor.js');
                servidor.postResultados(6, sessionAttributes.idUsuario, duracion, acierto, error, 4)
                  .then(() => {
                    // La solicitud se completó con éxito
                    console.log('Solicitud de resultados enviada correctamente');
                  })
                  .catch((error) => {
                    // Se produjo un error al realizar la solicitud
                    console.error('Error al enviar la solicitud de resultados:', error);
                  });
            
        } else {
            
            speakOutput = 'Error de nivel';
            if (
                  Alexa.getSupportedInterfaces(handlerInput.requestEnvelope)[
                    'Alexa.Presentation.APL'
                    ]
                    ) {
                        handlerInput.responseBuilder.addDirective({
                            type: 'Alexa.Presentation.APL.RenderDocument',
                            document: APL_simple,
                            datasources: {
                                  myData: {
                                    title: 'Error',
                                    body: 'No se han encontrado datos de juego',
                                  },
                                },
                              });
                            
                            }
            
        }
        
        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
        
    }
    
};


const HelloWorldIntentHandler = {
    canHandle(handlerInput) {
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'HelloWorldIntent';
    },
    handle(handlerInput) {
        const speakOutput = 'Hello World!';

        return handlerInput.responseBuilder
            .speak(speakOutput)
            //.reprompt('add a reprompt if you want to keep the session open for the user to respond')
            .getResponse();
    }
};

const HelpIntentHandler = {
    canHandle(handlerInput) {
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'AMAZON.HelpIntent';
    },
    handle(handlerInput) {
        const speakOutput = '¡Hola! ¿En qué puedo ayudarte?';

        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
    }
};

const CancelAndStopIntentHandler = {
    canHandle(handlerInput) {
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && (Alexa.getIntentName(handlerInput.requestEnvelope) === 'AMAZON.CancelIntent'
                || Alexa.getIntentName(handlerInput.requestEnvelope) === 'AMAZON.StopIntent');
    },
    handle(handlerInput) {
        const speakOutput = '¡Adiós!';

        return handlerInput.responseBuilder
            .speak(speakOutput)
            .getResponse();
    }
};
/* *
 * FallbackIntent triggers when a customer says something that doesn’t map to any intents in your skill
 * It must also be defined in the language model (if the locale supports it)
 * This handler can be safely added but will be ingnored in locales that do not support it yet 
 * */
const FallbackIntentHandler = {
    canHandle(handlerInput) {
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest'
            && Alexa.getIntentName(handlerInput.requestEnvelope) === 'AMAZON.FallbackIntent';
    },
    handle(handlerInput) {
        const speakOutput = 'Lo siento, no lo sé. Inténtalo de nuevo';

        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
    }
};
/* *
 * SessionEndedRequest notifies that a session was ended. This handler will be triggered when a currently open 
 * session is closed for one of the following reasons: 1) The user says "exit" or "quit". 2) The user does not 
 * respond or says something that does not match an intent defined in your voice model. 3) An error occurs 
 * */
const SessionEndedRequestHandler = {
    canHandle(handlerInput) {
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'SessionEndedRequest';
    },
    handle(handlerInput) {
        console.log(`~~~~ Session ended: ${JSON.stringify(handlerInput.requestEnvelope)}`);
        // Any cleanup logic goes here.
        return handlerInput.responseBuilder.getResponse(); // notice we send an empty response
    }
};
/* *
 * The intent reflector is used for interaction model testing and debugging.
 * It will simply repeat the intent the user said. You can create custom handlers for your intents 
 * by defining them above, then also adding them to the request handler chain below 
 * */
const IntentReflectorHandler = {
    canHandle(handlerInput) {
        return Alexa.getRequestType(handlerInput.requestEnvelope) === 'IntentRequest';
    },
    handle(handlerInput) {
        const intentName = Alexa.getIntentName(handlerInput.requestEnvelope);
        const speakOutput = `You just triggered ${intentName}`;

        return handlerInput.responseBuilder
            .speak(speakOutput)
            //.reprompt('add a reprompt if you want to keep the session open for the user to respond')
            .getResponse();
    }
};
/**
 * Generic error handling to capture any syntax or routing errors. If you receive an error
 * stating the request handler chain is not found, you have not implemented a handler for
 * the intent being invoked or included it in the skill builder below 
 * */
const ErrorHandler = {
    canHandle() {
        return true;
    },
    handle(handlerInput, error) {
        const speakOutput = 'Lo siento, no puedo hacer eso. Inténtalo de nuevo';
        console.log(`~~~~ Error handled: ${JSON.stringify(error)}`);

        return handlerInput.responseBuilder
            .speak(speakOutput)
            .reprompt(speakOutput)
            .getResponse();
    }
};

/**
 * This handler acts as the entry point for your skill, routing all request and response
 * payloads to the handlers above. Make sure any new handlers or interceptors you've
 * defined are included below. The order matters - they're processed top to bottom 
 * */
exports.handler = Alexa.SkillBuilders.custom()
    .addRequestHandlers(
        LaunchRequestHandler,
        RegistroUsuarioIntentHandler,
        CrearUsuarioIntentHandler,
        UsuarioRegistradoIntentHandler,
        BienvenidaIntentHandler,
        SeleccionarJuegoIntentHandler,
        OrdenarSilabasHandler,
        OrdenarSilabasIntentHandler,
        ContarSilabasHandler,
        ContarSilabasIntentHandler,
        AdivinanzasHandler,
        AdivinanzasIntentHandler,
        SilabaOcultaHandler,
        SilabaOcultaIntentHandler,
        AntonimosHandler,
        AntonimosIntentHandler,
        RepitePalabraHandler,
        RepitePalabraIntentHandler,
        HelloWorldIntentHandler,
        HelpIntentHandler,
        CancelAndStopIntentHandler,
        FallbackIntentHandler,
        SessionEndedRequestHandler,
        IntentReflectorHandler)
    .addErrorHandlers(
        ErrorHandler)
    .withCustomUserAgent('sample/hello-world/v1.2')
    .lambda();